/*-----------------------------------*/
/*                                   */
/* HT- Huatian Sensor Co., Ltd.      */
/*                                   */
/*-----------------------------------*/


//***********************************************************************************************************

#include "N76E003.h"
#include "SFR_Macro.h"
#include "Function_define.h"
#include "Common.h"
#include "Delay.h"
#include "stdio.h"

#define SYS_CLK_EN              0
#define SYS_SEL                 2
#define SYS_DIV_EN              0                   //0: Fsys=Fosc, 1: Fsys = Fosc/(2*CKDIV)
#define SYS_DIV                 1
#define I2C_CLOCK               80

//#define EEPROM_SLA              0x50
#define EEPROM_RD               1                                                                                 


#define PAGE_SIZE               2
#define PAGE_NUMBER             4

#define ERROR_CODE              0x78
#define TEST_OK                 0x00

bit I2C_Reset_Flag;

int pre1,pre2,t1,t2;
int P_sum,T_sum;

//========================================================================================================
void Init_I2C(void)
{
		P13_OpenDrain_Mode;					// Modify SCL pin to Open drain mode. don't forget the pull high resister in circuit
		P14_OpenDrain_Mode;					// Modify SDA pin to Open drain mode. don't forget the pull high resister in circuit
	
    /* Set I2C clock rate */
    I2CLK = I2C_CLOCK; 

    /* Enable I2C */
    set_I2CEN;                                   
}
//========================================================================================================//
void I2C_SI_Check(void)
{
		if (I2STAT == 0x00)
		{
				I2C_Reset_Flag = 1;
				set_STO;
				SI = 0;
				if(SI)
				{
						clr_I2CEN;
						set_I2CEN;
						clr_SI;
						clr_I2CEN;		
				} 	
		}	
}

void Date_Read(UINT8 EEPROM_SLA)
{
    UINT8  u8Count;
    
    set_STA;                               
    clr_SI;
    while (!SI);
    if (I2STAT != 0x08)                    
    {
        I2C_Reset_Flag = 1;
				printf("\nI2C 'Send STA' error");
				goto Read_Error_Stop;
    }

     
    /* Step6 */
    clr_STA;                                /* Clear STA and Keep SI value in I2CON */
    I2DAT = (EEPROM_SLA | EEPROM_RD);       /* Send (SLA+R) to EEPROM */
    clr_SI;
    while (!SI);
    if (I2STAT != 0x40)                     /* 0x40:  SLA+R has been transmitted; ACK has been received */              
    {
				I2C_Reset_Flag = 1;
        printf("\nI2C 'Send SLA+R' error");
			//	goto Read_Error_Stop;
    }

    for (u8Count = 0; u8Count <PAGE_SIZE; u8Count++)
    {
        set_AA;                             /* Set Assert Acknowledge Control Bit */
        clr_SI;
        while (!SI);
        if (I2STAT != 0x50)                 /* 0x50:Data byte has been received; NOT ACK has been returned */              
        {
						I2C_Reset_Flag = 1;
            printf("\nI2C 'No Ack' error");
						goto Read_Error_Stop;
        }
          
				if(u8Count==0)
				    pre1=I2DAT;
			  if(u8Count==1)
				    pre2=I2DAT;
				if(u8Count==2)
				    t1=I2DAT;
			  if(u8Count==3)
				    t2=I2DAT;				 
				
    }

    /* Step8 */
    clr_AA;                                 
    clr_SI;
    while (!SI);
    if (I2STAT != 0x58)                   
    {
        I2C_Reset_Flag = 1;
        printf("\nI2C 'Ack' error");
        goto Read_Error_Stop;
    }
    
	/* Step9 */    
	  clr_SI;
    set_STO;
		while (STO)                        /* Check STOP signal */
		{
			I2C_SI_Check();
			if (I2C_Reset_Flag)
				goto Read_Error_Stop;
		}
		
Read_Error_Stop: 
		if (I2C_Reset_Flag)
		{
				I2C_SI_Check();
			  printf("\nI2C Read error, test stop");
				I2C_Reset_Flag = 0;
		}
}

void P_T_change()
{

 
	P_sum=pre1<<8|pre2;
//	printf("\nADֵΪ");
	//printf("\%d",P_sum);
 
	

	


}

//========================================================================================================
void main(void)
{  float p; 

    
    Set_All_GPIO_Quasi_Mode;
		InitialUART0_Timer3(9600);
  
    /* Initial I2C function */
    Init_I2C();                                 //initial I2C circuit
    Date_Read (0x50);                     // read  pressure
    P_T_change();
	  printf("\nѹֵΪ");
	  p=(P_sum-1638)*0.003738175;
		printf("\%.2f",p);
	  printf("\nӭʹˮƷлл");
		 printf("\n");
	
   

    while (1);
/* =================== */
}

